import { Inject, Injectable } from '@nestjs/common';
import { CarpoolRouteProviderPort } from '../core/application/ports/carpool-route-provider.port';
import { CarpoolRoute } from '../core/application/types/carpool-route.type';
import { Waypoint } from '../core/application/types/waypoint.type';
import { Role } from '../core/domain/ad.types';
import { GetBasicRouteControllerPort } from '@modules/geography/core/application/ports/get-basic-route-controller.port';
import { AD_GET_BASIC_ROUTE_CONTROLLER } from '../ad.di-tokens';

@Injectable()
export class CarpoolRouteProvider implements CarpoolRouteProviderPort {
  constructor(
    @Inject(AD_GET_BASIC_ROUTE_CONTROLLER)
    private readonly getBasicRouteController: GetBasicRouteControllerPort,
  ) {}

  getBasic = async (
    roles: Role[],
    waypoints: Waypoint[],
  ): Promise<CarpoolRoute> =>
    await this.getBasicRouteController.get({
      roles,
      waypoints,
    });
}
